// Project 27 - Experimenting with Overflow Timers

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

ISR(TIMER1_OVF_vect)
{
    // Code to be executed when interrupt triggered from TIMER1 overflow
    // For this example, quickly blink LED on PB1
    PORTB = 0b00000010;    
    _delay_ms(5);
    PORTB = 0b00000000;   
}

void initOVI() 
// setup overflow interrupt and TIMER1
{
    TCCR1B = 0b00000010; //  set CS10 and CS11 for /8 prescaler
    TIMSK1 = 0b00000001; // turn on TIMER1 interrupt on overflow
    sei(); // turn on global interrupts
}

int main(void)
{
    DDRB = 0b11111111; // set PORTB register as outputs
    initOVI(); // setup overflow interrupt and TIMER1

    for(;;) // do something (blink LED on PB0
    { 
        PORTB = 0b00000001;    
        _delay_ms(100);
        PORTB = 0b00000000;    
        _delay_ms(100);
    }
    return 0;             
}