// Project 32 - Piezo and PWM

#include <avr/io.h>
#include <util/delay.h>

void startADC()
// set up the ADC
{
        ADMUX |= (1 << ADLAR)|(1 << MUX1);                 // Set ADC pin to 3
        ADCSRA |= (1 << ADEN)|(1 << ADPS1)|(1 << ADPS0);   // no prescaler
}

void initPWM(void)
{
    DDRB |= (1 << PORTB0);	                            // set PB0 as output
    // PB0 0C0A
    TCCR0A |= (1 << WGM01)|(1 << WGM00);                    // set timer mode to FAST PWM
    TCCR0A |= (1 << COM0A1);                                // connect PWM signal to pin (OC0A => PB0)
    TCCR0B |= (1 << CS00);                                  // no prescaler
}

int main(void)
{
    startADC();
    initPWM();
    for(;;)
    {	
        ADCSRA |= (1 << ADSC); // Start ADC measurement
        while (ADCSRA & (1 << ADSC) ); // Wait until conversion completes
        _delay_ms(5);
        OCR0A = ADCH;
    }
    return 0;
}