// Project 43 - Creating a Digital Thermometer with the thermometer.c Library

#include <avr/io.h>
#include <util/delay.h>
#include "thermometer.h"	 // use our new library

void startADC()
// Set up the ADC
{
    ADMUX |= (1 << REFS0);                 // Use AVcc pin with ADC
    ADMUX |= (1 << MUX2) | (1 << MUX0);    // use ADC5 (pin 28)
    ADCSRA |= (1 << ADPS1) | (1 << ADPS0); // prescaler for 1MHz (/8)
    ADCSRA |= (1 << ADEN);                 // enable ADC
}

int main(void)
{
    float temperature;	
    uint8_t finalTemp;
  
    startADC();
  
    DDRB = 0b11111111; // set PORTB as output
    for(;;)
    {
        temperature = readTMP36();          // get temperature from sensor
        finalTemp = (int)temperature;
	  
        displayNumber(finalTemp);
        _delay_ms(1000);
    }
    return 0;             
}
