// Project 44 - SPI bus and 74HC595 Shift Register

#include <avr/io.h>
#include <util/delay.h>

void setupSPI()
{
    PORTB |= (1 << 0); // latch pin high (SS)
    // set up SPI bus 
    SPCR = 0b01110000; 
} 

void dispNumSR(uint8_t value)    
// Displays a number 0-9 on the seven-segment LED display
{
    // latch pin low
    PORTB &= ~(1 << PORTB0);
    switch(value)
    // determine which byte of data to send to 74HC595
    {
        case 0 : SPDR = 0b11111100; break; // 0
        case 1 : SPDR = 0b01100000; break; // 1
        case 2 : SPDR = 0b11011010; break; // 2
        case 3 : SPDR = 0b11110010; break; // 3
        case 4 : SPDR = 0b01100110; break; // 4
        case 5 : SPDR = 0b10110110; break; // 5
        case 6 : SPDR = 0b10111110; break; // 6
        case 7 : SPDR = 0b11100000; break; // 7
        case 8 : SPDR = 0b11111110; break; // 8
        case 9 : SPDR = 0b11100110; break; // 9
    }
    while(!(SPSR & (1<<SPIF)));		// wait for SPI transmission to finish
    // latch pin high
    PORTB |= (1 << PORTB0);
}

int main(void)
{
    uint8_t i=0;
    DDRB = 0b11111111; // set PORTB as outputs	
    setupSPI();
    while (1) 
    {
        for (i=0; i<10; i++)
        {
            dispNumSR(i);
            _delay_ms(250);
        }
    }
}
