// Project 45 - SPI bus and Two 74HC595 Shift Registers

#include <avr/io.h>
#include <util/delay.h>

void setupSPI()
{
    PORTB |= (1 << 0); // latch pin high (SS)
    // set up SPI bus 
    SPCR = 0b01110000; 
} 

void dispNumSR(uint8_t value)    
// Displays a number 00-99 on the seven-segment LED displays
{
    uint8_t leftDigit;
    uint8_t rightDigit;
    // array holds bytes of data representing digits 0 to 9 for shift register control of LED displays
    uint8_t digitData[] = {0b11111100, 0b01100000, 0b11011010, 0b11110010, 0b01100110, 0b10110110, 0b10111110, 0b11100000, 0b11111110, 0b11100110};
  
    leftDigit = value/10;
    rightDigit = value%10;
  
    // latch pin low
    PORTB &= ~(1 << PORTB0);

    SPDR = digitData[rightDigit];
    while(!(SPSR & (1<<SPIF))); // wait for SPI transmission to finish
    SPDR = digitData[leftDigit];
    while(!(SPSR & (1<<SPIF))); // wait for SPI transmission to finish

    // latch pin high
    PORTB |= (1 << PORTB0); // wait for SPI transmission to finish
}

int main(void)
{
    uint8_t i=0;
    DDRB = 0b11111111; // set PORTB as outputs	
    setupSPI();
    while (1) 
    {
        for (i=0; i<100; i++)
        {
            dispNumSR(i);
            _delay_ms(250);
        }
    }
}